<?php
/**
 * @version		$Id: editor_utility.php,v 1.1 2009/07/27 12:59:10 juanca Exp $
 * @package		vpl. editor internationalization
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

//TODO change file name
require_once(dirname(__FILE__).'/../lib.php');
function vpl_param_tag($name,$data='',$plain=false){
	if($plain){
		return '<param name="'.$name.'" value="'.$data.'" />'."\n";
	}else{
		return '<param name="'.s($name).'" value="'.urlencode($data).'" />'."\n";
	}
}
function vpl_get_editor_tag($param_tags=''){
	$main='gui.Main';
	$codepath = vpl_mod_href('editor/appleteditor.jar');
	$applet='';
	$applet .='<object classid="java:'.$main.'.class" 
          type="application/x-java-applet"  id="appleteditorid"
   	      archive="'.$codepath.'" 
       	  height="100%" width="100%" >';
	$applet .= vpl_param_tag('codebase',vpl_mod_href('editor/'),true);
	$applet .= vpl_param_tag('code','gui.Main',true);
   	$applet .= vpl_param_tag('archive',$codepath,true);
	$applet.=$param_tags;
	$applet.='<object><a href="http://www.java.com/">Download Java</a> or/and update your browser</object>';
	$applet.='</object>';
	return $applet;
}

class vpl_editor_i18n{
	/**
	 * Return editor i18n string list
	 * @return  string of lines with format "word=i18nword"
	 **/
	protected static function editor_i18n_strings(){
		$list=array(
			'previous_page',
			'return_to_previous_page',
			'next_page',
			'go_next_page',
			'help',
			'contextual_help',
			'general_help',
			'edition',
			'file',
			'options',
			'new',
			'create_new_file',
			'file_name',
			'incorrect_file_name',
			'rename',
			'renameFile',
			'new_file_name',
			'delete',
			'delete_file',
			'delete_file_q',
			'undo',
			'undo_change',
			'redo',
			'redo_undone',
			'cut',
			'cut_text',
			'copy',
			'copy_text',
			'paste',
			'paste_text',
			'paste_system',
			'paste_system_text',
			'select_all',
			'select_all_text',
			'find_replace',
			'find_find_replace',
			'program_help',
			'page_unaccessible',
			'about',
			'help_about',
			'applet_code_editor_about',
			'line_number',
			'toggle_show_line_number',
			'next',
			'find_next_search_string',
			'replace',
			'replace_selection_if_match',
			'replace_find',
			'replace_find_next',
			'replace_all',
			'replace_all_next',
			'language_help',
			'console',
			'find',
			'case_sensitive',
			'replace_find',
			'font_size',
			'connecting',
			'connection_fail',
			'connected',
		    'connection_closed',
			'saving',
			'running',
			'evaluating',
			'debugging'
		);
		$ret ='';
		foreach($list as $word){
			$ret .=$word.'='.get_string($word,VPL)."\n";
		}
		return $ret;
	}

	public static function add_editori18n_field(& $mform){
		$mform->addElement('hidden','editori18n');
		$mform->setType('editori18n', PARAM_RAW);
		$mform->setDefault('editori18n', self::editor_i18n_strings());
	}

	public static function add_jseditori18n($return=false){
		$lang = vpl_get_lang();
		if($return){
			return vpl_include_js('setI18n(\''.$lang.'\');',true);
		}else{
			echo vpl_include_js('setI18n(\''.$lang.'\');',true);
		}
	}
	public static function get_params_tag(){
		return	vpl_param_tag('lang',vpl_get_lang()).
				vpl_param_tag('i18n',self::editor_i18n_strings());
	}
}
?>
