<?php
/**
 * @version		$Id: submission.php,v 1.26 2009/10/19 16:44:25 juanca Exp $
 * @package		vpl. process submission form
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('../../../config.php');
require_once('../lib.php');
require_once('submission_form.php');
require_once('../vpl.class.php');
require_once('../vpl_submission.class.php');

$id = required_param('id',PARAM_INT);
$vpl = new mod_vpl($id);
$userid = optional_param('userid',FALSE,PARAM_INT);
if(!$userid || $userid == $USER->id){//Make own submission
	$userid = $USER->id;
	$vpl->require_capability(VPL_SUBMIT_CAPABILITY);
	$vpl->network_check();
	$vpl->password_check();
}
else { //Make other user submission
	$vpl->require_capability(VPL_MANAGE_CAPABILITY);
}
$mform = new mod_vpl_submission_form('submission.php',$vpl);
$course = $vpl->get_course();
$instance = $vpl->get_instance();
if ($mform->is_cancelled()){
	redirect(vpl_mod_href('view.php','id',$id));
} else if ($fromform=$mform->get_data()){
	$files=array();
	for($i = 0 ; $i < $instance->maxfiles ; $i++ ){
		$attribute = 'file'.$i;
		$file = $mform->_form->getElement($attribute);
		if($file){
			$info = & $file->getValue();
			$data = $mform->get_file_content($attribute,true);
			//autodetect data file encode
			$encode = mb_detect_encoding($data, 'UNICODE, UTF-16, UTF-8, ISO-8859-1',true);
			if($encode > ''){ //If code detected
				$data = iconv($encode,'UTF-8',$data);
			}
			$files[] = array('name' => $info['name'], 'data' => $data);
		}
	}
	if($vpl->pass_submission_restriction($files, $error)){
		//Create submission record
		$submissiondata = new Object;
		$submissiondata->vpl = $instance->id;
		$submissiondata->userid = $userid;
		$submissiondata->datesubmitted = time();
		$submissiondata->comments = $fromform->comments;
		$submissionid = insert_record('vpl_submissions',$submissiondata,TRUE);
		if(!$submissionid){
			print_error('inserting vpl_submissions record');
			die;
		}
		$vpl->add_to_log('upload submission', vpl_rel_url('forms/submissionview.php','id',$id,'userid',$userid,'submissionid',$submissionid));
		//Save files
		$submission = new mod_vpl_submission($vpl,$submissionid);
		$submission->set_submited_file($files);
		$submission->remove_grade();
		$vpl->print_header(get_string('submission',VPL));
		$vpl->delete_overflow_submissions($userid);
		if($instance->evaluate && $instance->evaluateonsubmission){
			print_box(get_string('saved',VPL));
			redirect(vpl_mod_href('forms/evaluation.php','id',$id,'userid',$userid),
					get_string('evaluate',VPL),2);
		}
		notice(get_string('saved',VPL),vpl_mod_href('forms/submissionview.php','id',$id,'userid',$userid));
		//TODO execute test if required
	}
	vpl_redirect($error,vpl_mod_href('forms/submission.php','id',$id,'userid',$userid),5);
} else {
	//Display page
	$vpl->print_header(get_string('submission',VPL));
	$vpl->print_view_tabs(basename(__FILE__));
	$data = new object;
	$data->id = $id;
	$data->userid = $userid;
	$mform->set_data($data);
	$mform->display();
	$vpl->print_footer();
}

?>