/**
 * @version		$Id: grade.js,v 1.3 2009/10/22 12:54:36 juanca Exp $
 * @package		vpl. jscript function to help grade form
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/
/**
* resize the submission view div to greatest visible size 
*/ 
function resizeSView(){
	var offset=8;
	var page= window.document.getElementById('page');
	var sview=window.document.getElementById('submission_view');
	sviewRec = sview.getBoundingClientRect();
    pageRec = page.getBoundingClientRect();
    var diffHeight=(pageRec.bottom-pageRec.top)-(sviewRec.bottom-sviewRec.top);
    var newHeight=document.documentElement.clientHeight-diffHeight-offset;
    newHeight -= offset;
    if(newHeight <200) newHeight=200;
    sview.style.height  = newHeight+'px';
}


/* Set the resize controler */

window.onresize=resizeSView;

/**
* Recalculate numeric grade from the max sustracting grades found at the end of
* lines.
* valid grade format: "- text (-grade)" 
*/ 
function vpl_calculateGrade(maxgrade){
	var form1 = window.document.getElementById('form1');
	text = new String(form1.comments.value);
	grade = new Number(maxgrade);
	while(text.length > 0) {
		/* Separate next line*/
		line = new String();
		var i;
		for(i=0; i < text.length; i++){
			if(text.charAt(i) == '\n') break;
			if(text.charAt(i) == '\r') break;
		}
		line = text.substr(0,i);
		if(i<text.length)
			text = text.substr(i+1,(text.length-i)-1);
		else
			text = '';
		if(line.length == 0) continue;

		/* Is a message title line */
		if(line.charAt(0) == '-'){
			nline = new String();
			for(i=0; i < line.length; i++)
				if(line.charAt(i) != ' ') nline += line.charAt(i);
			if(nline.length == 0) continue;
			/* End of line format (-grade) */
			if(nline.charAt(nline.length-1) == ')'){
				pos = nline.lastIndexOf('(');
				if(pos == -1) continue;
				rest= nline.substr(pos+1,nline.length-2-pos);
				/* update grade with rest */
				if(rest < 0) grade += new Number(rest);
			}
		}
	}
	/*No negative grade*/
	if(grade <0) grade = 0;
	/*Max two decimal points*/
	grade = Math.round(100*grade)/100;
	form1.grade.value = grade;
};

/**
 * Add new comment to the form
 * comment string comment to add
 */
function vpl_addComment(comment) {
	if(comment.length==0) return;
	comment = '-'+comment;
	var form1 = window.document.getElementById('form1');
	text = new String(form1.comments.value);
	if(text.indexOf(comment,0) >=0) { /*Comment already in form*/
		return;
	}
	/* Next 3 lines are based on moodle code */
	if ( form1.comments.createTextRange && form1.comments.caretPos) {
		var caretPos = form1.comments.caretPos;
		caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? comment + ' ' : comment;
	} else {
		if(text.length>0){
			end = text[text.length-1];
			if(end != '\c' && end != '\r')	
				comment = '\r'+comment;
		}
		form1.comments.value += comment;
	}
	form1.comments.focus();
};

function vpl_savecaret(){
	var form1 = window.document.getElementById('form1');
	form1.comments.caretPos=document.selection.createRange();
}

var form1 = window.document.getElementById('form1');
form1.comments.onblur=vpl_savecaret;
