<?php
/**
 * @version		$Id: listsimilarity.php,v 1.5 2009/08/08 11:51:49 juanca Exp $
 * @package		vpl. List most similar submission files 
 * @copyright	Copyright (C) 2009 Juan Carlos Rodríguez-del-Pino. All rights reserved.
 * @license		GNU/GPL, see LICENSE.txt or http://www.gnu.org/licenses/gpl-2.0.html
 * @author		Juan Carlos Rodriguez-del-Pino
 **/

require_once('../../../config.php');
require_once('../lib.php');
require_once('../vpl.class.php');
require_once('../vpl_submission.class.php');
require_once('similarity_factory.class.php');
require_once('similarity_base.class.php');
require_once('similarity_form.class.php');

$id = required_param('id', PARAM_INT);
$vpl = new mod_vpl($id);
$vpl->require_capability(VPL_SIMILARITY_CAPABILITY);
$vpl->add_to_log('view similarity', vpl_mod_href('similarity/similarity_form.php','id',$id));
//Print header
$vpl->print_header(get_string('listsimilarity',VPL));
$vpl->print_view_tabs(basename(__FILE__));
$form = new vpl_similarity_form('listsimilarity.php',$vpl);
if(!($fromform = $form->get_data())){
	print_error('readingdata',VPL);
}
//Get filelist to search
$filesselected=array();
$filelist = $vpl->get_required_fgm()->getFileList();
$num=0;
foreach($filelist as $filename){
	if(isset($fromform->{'file'.$num})){
		$filesselected[$filename]=true;
	}
	$num++;
}

$usernumber=0;
$nwm=0;
$simil = array();
vpl_similarity::scan_activity($simil,$vpl,$filesselected);
$il = count($simil);
if(isset($fromform->scanactivity) && $fromform->scanactivity>0){
	$othervpl=new mod_vpl($fromform->scanactivity);
	$othervpl->require_capability(VPL_SIMILARITY_CAPABILITY);
	vpl_similarity::scan_activity($simil,$othervpl,$filesselected);
}
if(isset($fromform->scanzipfile) && $fromform->scanzipfile>''){
	vpl_similarity::scan_zip($simil,$fromform->scanzipfile,$vpl,$filesselected);
}
if(isset($fromform->scandirectory) && $fromform->scandirectory>''){
	$basedir = $CFG->dataroot.'/'.$vpl->get_course()->id;
	vpl_similarity::scan_directory($simil,$basedir.'/'.$fromform->scandirectory,$filesselected);
}
if(isset($fromform->searchotherfile)){
	$il = count($simil);
}
$firstname = get_string('firstname');
$lastname  = get_string('lastname');
if ($CFG->fullnamedisplay == 'lastname firstname') {
	$name = $lastname.' / '.$firstname;
} else {
	$name = $firstname.' / '.$lastname;
}
$with	= get_string('similarto',VPL);
$table = new stdClass();
$table->head  = array ('#',$name, $with);
$table->align = array ('rigth','left', 'left');
$table->size = array ('','60','60');

$dist1=array();
$dist2=array();
for($i=0;$i<=100;$i++){
	$dist1[$i]=0;
	$dist2[$i]=0;
}
$minlevel = (int)$fromform->level;
$jl=count($simil);
for($i=0; $i<$il; $i++){
	$current=&$simil[$i];
	$current_type=$current->get_type();
	$with='';
	for($j=$i+1;$j<$jl; $j++){
		$other=&$simil[$j];
		if($current_type != $other->get_type()){
			continue;
		}
		$s1=$current->similarity1($other);
		$dist1[(int)$s1]++;
		$s2=$current->similarity2($other);
		$dist2[(int)$s2]++;
		if($s1>=$minlevel /*|| $s2>$minlevel*/){
			if($with>''){
				$with .= '<br />';
			}
			$with .= (int)$s1.' / '.(int)$s2.' ';
			$with .= $other->show_info();
		}
	}
	if($with>''){
		$usernumber++;
		$usertext =	$current->show_info();
		
		$table->data[] = array ($usernumber,$usertext,$with);		
	}
}
if($usernumber>0){
	print_table($table);
}

$vpl->print_footer();
?>
